---
title: PaymentMethodChangeEvent.methodDetails
slug: Web/API/PaymentMethodChangeEvent/methodDetails
tags:
  - API
  - Commerce
  - Payment Method
  - Payment Request
  - Payment Request API
  - PaymentMethodChangeEvent
  - Property
  - Reference
  - methodDetails
  - payment
  - paymentmethodchange
---
<div>{{securecontext_header}}{{APIRef("Payment Request API")}}</div>

<p>The read-only <code><strong>methodDetails</strong></code> property of the <span class="seoSummary">{{domxref("PaymentMethodChangeEvent")}} interface is an object containing any data the payment handler may provide to describe the change the user has made to their payment method.</span> The value is <code>null</code> if no details are available.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>details</em> = <em>paymentMethodChangeEvent</em>.methodName;
</pre>

<h3 id="Value">Value</h3>

<p>An object containing any data needed to describe the changes made to the payment method. The contents vary depending on the actual payment method chosen, so you will need to refer to the {{domxref("PaymentMethodChangeEvent.methodName", "methodName")}} property first, then inerpret the <code>methodDetails</code> after that.</p>

<p>The default value is <code>null</code>, indicating that no additional details are available.</p>

<h2 id="Example">Example</h2>

<p>This example uses the {{event("paymentmethodchange")}} event to watch for changes to the payment method selected for Apple Pay, in order to compute a discount if the user chooses to use a Visa card as their payment method.</p>

<pre class="brush: js">request.onpaymentmethodchange = function(ev) {
  const { type: cardType } = ev.methodDetails;
  const newStuff = {};
  if (ev.methodName === "https://apple.com/apple-pay") {
    switch (cardType) {
      case "visa":
        // do Apple Pay specific handling for Visa card...
        // methodDetails contains the card information
        const result = calculateDiscount(ev.methodDetails);
        Object.assign(newStuff, result);
        break;
    }
  }
  // finally...
  ev.updateWith(newStuff);
};
const response = await request.show();</pre>

<p>Note that the <code>methodDetails</code> property is being used by the <code>calculateDiscount()</code> function to compute any payment discount, then {{domxref("PaymentRequestUpdateEvent.updateWith", "updateWith()")}} is called to update the event with the computed update.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#dom-paymentmethodchangeevent-methoddetails','PaymentMethodChangeEvent.methodDetails')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentMethodChangeEvent.methodDetails")}}</p>
</div>
